require "import"
import "android.content.Context"
import "android.content.Intent"
import "android.net.Uri"
import "android.widget.Button"
import "android.widget.LinearLayout"
import "android.widget.TextView"
import "android.widget.EditText"
import "android.media.MediaPlayer"
import "android.media.MediaRecorder"
import "java.io.File"
import "android.os.Environment"
import "com.androlua.LuaDialog"
import "android.content.SharedPreferences"
local dlg, mainDlg
local context = service
local folderPath = Environment.getExternalStorageDirectory().getPath() .. "/Grabaciones de Radio Amistad"
local mediaRecorder
local isRecording = false
local outputFile
local sharedPrefs = service.getSharedPreferences("RadioAmistadPrefs", Context.MODE_PRIVATE)
local editor = sharedPrefs.edit()
local avisoMostrado = sharedPrefs.getBoolean("avisoMostrado", false)
local function mostrarInterfaz()
local streamUrl = "https://a2.asurahosting.com/listen/radio_amistad/radio.mp3"
local function createRecordingFolder()
local folder = File(folderPath)
if not folder.exists() then
folder.mkdirs()
end
end
local function showRecordingManager()
dlg = LuaDialog(service)
local layout = {
LinearLayout;
orientation = "vertical";
{
TextView;
text = "Administrar Grabación";
textSize = "18sp";
gravity = "center";
layout_marginBottom = "10dp";
};
{
TextView;
text = File(outputFile).getName();
textSize = "14sp";
gravity = "center";
layout_marginBottom = "10dp";
};
{
Button;
text = "Reproducir";
onClick = function()
local player = MediaPlayer()
player.setDataSource(outputFile)
player.prepare()
player.start()
end;
};
{
Button;
text = "Renombrar";
onClick = function()
local renameDlg = LuaDialog(service)
renameDlg.setTitle("Renombrar grabación")
renameDlg.setMessage("Ingrese el nuevo nombre para la grabación:")
local input = EditText(service)
input.setText(File(outputFile).getName())
renameDlg.setView(input)
renameDlg.setPositiveButton("Guardar", function()
local newName = input.getText().toString()
local newFile = File(folderPath, newName)
File(outputFile).renameTo(newFile)
outputFile = newFile.getPath()
service.asyncSpeak("Grabación renombrada")
end)
renameDlg.setNegativeButton("Cancelar", nil)
renameDlg.show()
end;
};
{
Button;
text = "Compartir";
onClick = function()
service.shareFile(outputFile)
dlg.dismiss()
mainDlg.dismiss()
end;
};
{
Button;
text = "Eliminar";
onClick = function()
local confirmDlg = LuaDialog(service)
confirmDlg.setTitle("Confirmar eliminación")
confirmDlg.setMessage("¿Estás seguro de que deseas eliminar esta grabación?")
confirmDlg.setPositiveButton("Sí", function()
File(outputFile).delete()
service.asyncSpeak("Grabación eliminada")
dlg.dismiss()
mainDlg.dismiss() -- Cerrar toda la interfaz
end)
confirmDlg.setNegativeButton("No", nil)
confirmDlg.show()
end;
};
{
Button;
text = "Cerrar";
onClick = function()
dlg.dismiss()
end;
};
}
dlg.setView(loadlayout(layout))
dlg.show()
end
local function startRecording()
if _G.mediaPlayerStream and _G.mediaPlayerStream.isPlaying() then
createRecordingFolder()
local timeStamp = os.date("%Y%m%d_%H%M%S")
outputFile = folderPath .. "/Grabación de Radio Amistad " .. timeStamp .. ".mp3"
mediaRecorder = MediaRecorder()
mediaRecorder.setAudioSource(MediaRecorder.AudioSource.MIC)
mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
mediaRecorder.setAudioEncodingBitRate(192000)
mediaRecorder.setAudioSamplingRate(44100)
mediaRecorder.setOutputFile(outputFile)
mediaRecorder.prepare()
mediaRecorder.start()
isRecording = true
btnRecord.text = "Detener grabación"
service.asyncSpeak("Grabando...")
else
service.asyncSpeak("El streaming debe estar en reproducción para grabar")
end
end
local function stopRecording()
if isRecording then
mediaRecorder.stop()
mediaRecorder.release()
mediaRecorder = nil
isRecording = false
btnRecord.text = "Grabar"
service.asyncSpeak("Grabación detenida")
if _G.mediaPlayerStream and _G.mediaPlayerStream.isPlaying() then
_G.mediaPlayerStream.pause()
_G.isPlaying = false
btnPlayPause.text = "Reproducir Streaming"
service.asyncSpeak("Streaming pausado")
end
showRecordingManager()
end
end
local function openLink(url)
service.playSoundTick() -- Sonido al abrir enlaces
local intent = Intent(Intent.ACTION_VIEW)
intent.setData(Uri.parse(url))
intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
pcall(function()
service.startActivity(intent)
end)
mainDlg.dismiss()
end
local function exitInterface()
if _G.mediaPlayerStream and _G.mediaPlayerStream.isPlaying() then
service.asyncSpeak("Saliste de la interfaz, pero el streaming sigue activo")
else
service.asyncSpeak("Saliendo del complemento")
end
if isRecording then
stopRecording()
end
mainDlg.dismiss()
end
local function togglePlayback()
if _G.mediaPlayerStream and _G.mediaPlayerStream.isPlaying() then
_G.mediaPlayerStream.pause()
_G.isPlaying = false
btnPlayPause.text = "Reproducir Streaming"
service.asyncSpeak("Streaming pausado")
if isRecording then
stopRecording()
end
else
if _G.mediaPlayerStream then
_G.mediaPlayerStream.release()
end
_G.mediaPlayerStream = MediaPlayer()
_G.mediaPlayerStream.setDataSource(streamUrl)
_G.mediaPlayerStream.setOnPreparedListener(function()
_G.mediaPlayerStream.start()
_G.isPlaying = true
btnPlayPause.text = "Pausar Streaming"
service.asyncSpeak("Streaming iniciado")
end)
_G.mediaPlayerStream.prepareAsync()
end
end
local mainLayout = {
LinearLayout;
orientation = "vertical";
{
TextView;
text = "Radio Amistad Oficial";
textSize = "18sp";
gravity = "center";
layout_width = "match_parent";
layout_marginBottom = "10dp";
};
{
TextView;
text = "Desarrollado por Emmanuel El Fantasma, Ángel Gómez , y Rudyy1224.";
textSize = "14sp";
gravity = "center";
layout_width = "match_parent";
layout_marginBottom = "10dp";
};
{
Button;
id = "btnPlayPause";
text = _G.isPlaying and "Pausar Streaming" or "Reproducir Streaming";
onClick = togglePlayback;
};
{
Button;
id = "btnRecord";
text = "Grabar";
onClick = function()
if isRecording then
stopRecording()
else
startRecording()
end
end;
};
{
Button;
text = "Únete a Radio Amistad";
onClick = function()
openLink("https://radioamistad.ar/unete-a-nuestro-equipo/")
end;
};
{
Button;
text = "Programación de Radio Amistad";
onClick = function()
openLink("https://radioamistad.ar/programacion/")
end;
};
{
Button;
text = "Donar a Radio Amistad";
onClick = function()
openLink("https://radioamistad.ar/donar/")
end;
};
{
Button;
text = "Sígueme en mi canal de Telegram";
onClick = function()
openLink("https://t.me/Pluginimpaciente")
end;
};
{
Button;
text = "Salir";
onClick = exitInterface;
};
}
mainDlg = LuaDialog(service)
mainDlg.setView(loadlayout(mainLayout))
mainDlg.show()
end
if not avisoMostrado then
local avisoDlg = LuaDialog(service)
avisoDlg.setTitle("Aviso Importante")
avisoDlg.setMessage("Esto aparecerá una sola vez, así que preste mucha atención y, si es necesario, copie esto al portapapeles del lector.\n\nSean todos bienvenidos a la versión 2.0 del plugin de Radio Amistad. Esta versión trae corrección de un error que había y también una actualización importante. Vamos a comenzar por lo primero: la corrección que se realizó. Verán, cuando accedían a uno de los enlaces presionando uno de los botones, por ejemplo, 'Unirse a Radio Amistad', el complemento no se cerraba automáticamente. Bien, ahora eso está corregido; el complemento se cierra cuando se da clic en uno de los botones para ir a cierta parte de la página web de Radio Amistad.\n\nCon esto dicho, ahora sí vamos con la súper actualización. La súper actualización de esta versión es que se ha integrado una grabadora a este plugin. Así es, a partir de ahora, si hay algún momento destacado que quieras grabar de tu programa favorito, podrás hacerlo con total confianza. Pero aquí les va algo que deben tomar en cuenta: la grabadora se podrá utilizar mientras el streaming se esté reproduciendo. Por ejemplo, si estás escuchando música y quieres grabar una canción en específico, se activará la grabadora; sin embargo, si el streaming está pausado, no podrás utilizarla. Igualmente, cuando pauses el streaming y estés grabando, la grabación se pausará automáticamente. Además, se mostrará el administrador de esa grabación, que te permitirá hacer lo siguiente: reproducir la grabación, Renombrar la grabación, compartir la grabación y eliminar la grabación. También integra un botón para cerrar, el cual cerrará ese diálogo.\n\nTambién, cuando detengas la grabación, el streaming se pausará automáticamente. Además, cuando salgas de la interfaz mientras estás grabando, tanto la grabación como el streaming se pausarán automáticamente. No se preocupen, que si no están grabando, podrán salir de la interfaz libremente.\n\nEso solo aplica cuando no estés grabando. Ojo, podrán seguir escuchando el streaming siempre y cuando no estén grabando, y esto sirve para cuando quieras salir de la interfaz y hacer otras cosas.")
avisoDlg.setPositiveButton("Aceptar", function()
editor.putBoolean("avisoMostrado", true)
editor.commit()
mostrarInterfaz()
end)
avisoDlg.show()
else
mostrarInterfaz()
end